#! /usr/local/bin/wish

option add *Scrollbar.takeFocus 0
option add *Text.hardTab 1

source ../lib/util.tcl
source ../lib/framework.tcl
source ../lib/text.tcl

set fname ""
proc load {} {
    global fname
    set fname [tk_getOpenFile]
    if {$fname != ""} {
	.t.txt delete 1.0 end
	set fd [open $fname]
	.t.txt insert end [read $fd]
	close $fd
	.t.txt mark set insert 1.0
        .t.txt afterLoad
    }
}
proc save {} {
    global fname
    if {$fname == ""} {
        saveAs
    } else {
	set fd [open $fname w]
	puts -nonewline $fd [.t.txt get 1.0 "end - 1 chars"]
	close $fd
	.t.txt afterSave
    }
}
proc saveAs {} {
    global fname
    set fname [tk_getSaveFile]
    if {$fname != ""} {
	set fd [open $fname w]
	puts -nonewline $fd [.t.txt get 1.0 "end - 1 chars"]
	close $fd
	.t.txt afterSave
    }
}

set nonce 0
proc clone {} {
    global nonce
    incr nonce
    toplevel .$nonce

    pack [scrollbar .$nonce.sx -command ".$nonce.txt xview" -orient horizontal] -side bottom -fill x
    pack [scrollbar .$nonce.sy -command ".$nonce.txt yview"] -side right -fill y
    .t.txt clone .$nonce.txt
    .$nonce.txt configure -xs ".$nonce.sx set" -ys ".$nonce.sy set" -wrap none
    pack .$nonce.txt -expand true -fill both
}


pack [frame .z] -side bottom -fill x
pack [frame .t -height 400] -expand true -fill both

pack [scrollbar .t.sx -command ".t.txt xview" -orient horizontal] -side bottom -fill x
pack [scrollbar .t.sy -command ".t.txt yview"] -side right -fill y
pack [two_text .t.txt -xs ".t.sx set" -ys ".t.sy set" -wrap none] -expand true -fill both

pack [button .z.o -text "Open" -command load] -side left
pack [button .z.s -text "Save" -command save -state disabled] -side left
pack [button .z.a -text "SaveAs" -command saveAs] -side left
pack [button .z.c -text "Copy" -command {puts [.t.txt get sel.first sel.last]} -state disabled] -side left
pack [button .z.u -text "Undo" -command {.t.txt undo} -state disabled] -side left 
pack [button .z.r -text "Redo" -command {.t.txt redo} -state disabled] -side left
pack [button .z.p -text "Clone" -command clone] -side left
pack [button .z.x -text "Exit" -command exit] -side left
pack [button .z.xx -text "xx" -command ".t.txt insert insert abc sel"] -side right
pack [label  .z.w -textvariable ovw -width 6] -side right
pack [label  .z.l -textvariable pos] -side right

set w .t.txt
bind $w <<ModOn>>   { .z.s configure -state normal   }
bind $w <<ModOff>>  { .z.s configure -state disabled }
bind $w <<SelOn>>   { .z.c configure -state normal   }
bind $w <<SelOff>>  { .z.c configure -state disabled }
bind $w <<UndoOn>>  { .z.u configure -state normal   }
bind $w <<UndoOff>> { .z.u configure -state disabled }
bind $w <<RedoOn>>  { .z.r configure -state normal   }
bind $w <<RedoOff>> { .z.r configure -state disabled }
bind $w <<OverwriteOn>>  { set ovw "Over"       }
bind $w <<OverwriteOff>> { set ovw "Insert"     }
bind $w <<PosChanged>>   { set pos "X: %x Y: %y"}

set pos "X: 1 Y: 1"
set ovw "Insert"
focus .t.txt
