.TH two_editor n text\ editor\ widget TWO\ library
.ds )H FJL
.ds ]W http://fjl.de/two/
.SH NAME
two_editor \- Text editor widget
.SH SYNOPSIS
.CI package\ require\ twoEditor \ ?1.0?
.br
.C two_editor
.I pathName
.RI ? options ?
.SH DESCRIPTION
.C two_editor
is an ASCII text editor widget. It extends the two_text(n) widget (also part of
this library). It provides methods to open/save files into the widget and
can be split into two parts which show different parts of the same
file.
.SH COMMANDS
The
.C two_editor
widget command takes all of the two_text(n) commands and additionally the following:
.RS
.TP
.IC pathName\  open \ filename
Load file 
.I filename
into buffer (equivalent to 
.CR configure\ \-file ).
.TP
.IC pathName\  close
Close the current buffer
.TP
.IC pathName\  save \ ?filename?
Save the current buffer to file
.IR filename .
If filename is omitteted then the name of the currently opened file will be
used.
.TP
.IC pathName\  filename
Returns the name of currently opened file or the name of the buffer.
.TP
.IC pathName\  mtime
Returns the mtime of the opened file as of the time of last
opening or saveing the file. Returns
.I 0
on new files.
.TP
.IC pathName\  mtimeReset
Reset the seaved mtime to the current mtime of the opened file.
.TP
.IC pathName\  splitState
Returns 
.I 1
if editor is split (equivalent to 
.CR cget\ \-split ).
.TP
.IC pathName\  isNew
Returns 
.I 1
if editor holds a new file (or buffer), i.e. no name has been given to it.
.TP
.IC pathName\  isFile
Returns 
.I 1
if editor holds a file (with a name, i.e. this is not a buffer, nor is
it a new and unnamed file.
.TP
Returns 
.I 1
if editor holds a buffer (with a name, i.e. this is not a file, nor is
it a new and unnamed buffer.
.TP
.IC pathName\  setFocus
Set the focus on the proper subwidget.
.TP
.IC pathName\  repaint
Recalculate the higlighting for this editor if highlighting
is configured.
.RE
.SH OPTIONS
The
.C two_editor
command takes all options of the two_text(n) widget plus to following options:
.RS
.TP
.CI \-file \ filename
Initially load file
.I filename
into the buffer. If omitted, a new name
.C New\ #
will be generated and no file opened.
.TP
.CI \-buffer \ buffername
Apply a new to an editor, but this is no real file, so no file
will be opned. If omitted, a new name
.C New\ #
will be generated.
.TP
.CI \-closecmd \ command
Call command when a modified buffer (i.e. file not saved since
last changes) is about to be destroyed. The widget is actually only
destroyed if this command returns true (or no command has been set set).
.TP
.CI \-openerrcmd \ command
Call command when opening a file fails. Two parameters are appended:
the name of the file and the error message. You should test if a file
is readable prior to openeing it, but that alone would open up a race
condition: the (short) time gap between the check and actually opening
the file might be sufficient for changes (due to external influences).
To not fire up an internal error in such a case use this option.
.TP
.CI \-saveerrcmd \ command
Call command when saveing a file fails. Two parameters are appended:
the name of the file and the error message. You should test if a file
is writable prior to saving it, but that alone would open up a race
condition: the (short) time gap between the check and actually saving
the file might be sufficient for changes (due to external influences).
To not fire up an internal error in such a case use this option.
.TP
.CI \-split \ TCL_BOOLEAN
If set to TRUE, then editor is set to display two views of the same file.
Defaults to FALSE.
.TP
.CI \-scrollx \ TCL_BOOLEAN
If TRUE, then the editor will do no line wrapping and use an
automatic horizontal scrollbar. Defaults to TRUE.
.TP
.C \-style
Set the
.I style
of the splitter used by the editor:
.C unix
for more UNIX-like or
.C windows
for a look and feel like on windows.
.TP
.CI \-match \ TCL_BOOLEAN
If TRUE, then the editor will highlight matching parens,
braces, and brackets while typing. Defaults to TRUE.
.TP
.CI \-highlight \ TCL_BOOLEAN
If TRUE, then the editor will perform syntax highlighting based
on the following options. Defaults to FALSE.
.TP
.CI \-comment \ list
List with even number of elements. Each pair is a description
(Regular Expression without parantheses) of start and stop of comments.
.TP
.CI \-string \ list
List with even number of elements. Each pair is a description
(Regular Expression without parantheses) of start and stop of strings.
.TP
.CI \-keywords \ list
List of keywords.
.TP
.CI \-keywordRE \ expression
A single Regular Expression (without parantheses) describing what
keywords are. This is an alternative to the
.I keywords
option (can\'t use both).
.SH VIRTUAL EVENTS
The
.C two_editor
forwards all virtual events of the two_text(n) widget, and additinally
generates the following event:
.RS
.TP
.IR <<SplitOn>>\  and\  <<SplitOff>>
The Editor has been split (On) or joined again (Off).
.RE
.SH ELEMENTS
The
.C two_editor
is built from a surrounding frame (class
.IR TwoEditor )
and to slave frames (no class). Those two frames each contain a
two_text(n) widget and two automatic scrollbars autosb(n). The horizontal
autosb is not used if the
.I \-scrollx
option is set to FALSE. Fonts used (and created if non-existant) by the
.C editor
widget are:
.RS
.TP
.I twoEditorS
Used for highlighting strings
.TP
.I twoEditorC
Used for highlighting comments
.TP
.I twoEditorK
Used for highlighting keywords
.RE
.PP
Both slave frames (with the two_text widgets) are managed by a splitter(n).
Only one frame is visible if the editor is not split.
.SH AUTHOR
Frank J. Leitner
.br
frank@fjl.de
.SH SEE ALSO
two_text(n), two_autosb(n), two_splitter(n).
