.TH two_util n miscellaneus\ utilitites TWO\ library
.ds )H FJL
.ds ]W http://fjl.de/two/
.SH NAME
two_busy \- show busy cursor and block interacition
.br
two_center \- center window on the screen
.br
two_ct \- Retrieve current toplevel
.br
two_invoke \- Invoke a button with visual feedback
.br
two_kshPwd \- Replacement for cd and pwd to behave like the Korn shell
.br
two_mb \- Simplified messagebox
.br
two_noExportImport \- Disable all copying to and from the application
.br
two_showCenter \- Show window and center it on the screen
.SH SYNOPSIS
.CI package\ require\ twoUtil \ ?1.0?
.br
.C two_busy
.I TCL_BOOLEAN widget ?widgets?
.br
.C two_center
.IR widget\  [ parent ]
.br
.C two_ct
.br
.C two_invoke
.I widgetpath
.br
.C two_mb
.I options
.br
.C two_noExportImport
.br
.C two_showCenter
.IR widget\  [ parent ]
.SH DESCRIPTION
.SS two_busy
Show a busy (watch) cursor and block all user interaction. This is
achieved through a transparent frame which is placed on top of
all child widgets. If the first arguments is FALSE, this frame
is removed and all returns to normal behavior.
.br
It's a known bug that transparent frames don\'t propagate redraw
events, so the underlying widgets don\'t repaint at all. Looks like
a blocked application. Won\'t make any difference if your app really
blocks, but if it doesn\'t... it\'s ugly.
.SS two_center
This one will move
.I widget
to the center of the screen. If the optional
.I parent
is given, then this parent will be deiconified and
.I widget
will be placed on top of it, using the same virtual screen. The
.I parent
defaults to \'.\'.
.SS two_ct
Returns the current toplevel, i.e. the toplevel which
currently contains the focus. If the application doesn\'t
have the focus, a single \'.\' is returned.
.SS two_invoke
Invoke a Tk button named
.IR widgetpath .
Before actually calling the invoke method, the button is flashed
as if it were pressed with the mouse. Using this function with a
label will set the keyboard focus to the next widget in the focus
order.
.SS two_kshPwd
Installs a replacement for
.C pwd
and
.C cd
to make both of them behave like the built-in commands in the Korn shell
.RI ( ksh )
or the ones in the HP-UX Posix Shell. Users might especially want to use
this if they keep getting
.C /tmp_mnt/
on their paths.
.PP
Some background: There are two ways to retrieve the current working
directory. The one used by
.I tclsh
is the C-Library version which basically walks up the
.RC \' .. \'
links in each directory to find the generic name of the current
working directory. This is unique as long as there are no symbolic
links to directories: those links make it possible to access a
directory through different paths, but the generic way to retrieve
the name of the current directory will always return the same name.
.PP
What the ksh does different now is that it stores the user-supplied
path name and returns this one on
.C pwd
requests. Relative
.C cd
commands are interpreted relative to the stored pathname, and
.RC \' .. \'
removes the last component of the path rather than using the
file systems uplink. The replacement commands installed by
.C two_kshPwd
apply these semantics, which will affect, e.g., the
.C tk_getOpenFile
commands.
.PP
Doing it the original tclsh way gets rather annoying if you are using the
.I automounter
on UNIX Systems: this beast will mount directories on demand and
unmount them after some idle time. The auto mounting is triggered
by accessing anything within the directory tree which should be
mounted. Unfortunatly, the automounter will set the real mount point in
.C /tmp_mnt/
and only use symbolic links in the place where you would expect the
mount point to live.
.PP
The problem with all that is that a /tmp_mnt/ path is not only less
beautiful, but also will not trigger the re-mounting of a directory.
.PP
The fact that there are several ways to interpret
.RC \' .. \'
and all of them are mixed in several places has obvously bitten
almost any UNIX user at some time. Please note that this replacement
does only affect
.C cd
and
.C pwd
commands; accessing a file for
.C open
or any other command will
.I not
use these new semantics! But then, this is the same in ksh.
.SS two_mb
Just a thin wrapper around the
.C tk_messageBox
which sets the parent widget to a reasonable value.
.SS two_noExportImport
Disables all copying to and from the application. Disabling the
export function is easy through
.C exportSelection
.IR none ,
but disabling the importing of the seletion is a bit trickier. It is
achieved here through replacing the
.C selection
and
.C clipboard
commands. Caveat: You\'ll have to call this function before instantiating
any widget in order to make the 
.C option
.I add
used by this function work.
.SS two_showCenter
Will show the
.I widget
(i.e. raise/deiconify it). If the widget was withdrawn,
it will be moved to the center of the screen. See also
.CR two_center .
Note that mapped and iconified widgets are made visible, without
changing their former position, while only withrawn widgets
are moved.
.SH AUTHOR
Frank J. Leitner
.br
frank@fjl.de
.SH SEE ALSO
button(n),
clipboard(n),
option(n),
selection(n),
tk_messageBox(n),
wm(n).
