.TH two_shell n fake\ shell\ widget TWO\ library
.ds )H FJL
.ds ]W http://fjl.de/two/
.SH NAME
two_shell \- Fake shell widget with very limited terminal emulation
.SH SYNOPSIS
.CI package\ require\ twoShell \ ?1.0?
.br
.C two_shell
.I pathName
.RI ? options ?
.SH DESCRIPTION
.C two_shell
is a fake shell widget used to run interactive applications. It shows a
fake prompt and fake command string. Only very limited terminal emulation
is done (bell and delete). Requires
.IR Expect .
.SH COMMANDS
The
.C two_shell
widget command takes all of the text(n) commands and additionally the following:
.RS
.TP
.IC pathName\  run \ UnixCommand\ ?-fake\ string?\ ?-aftercmd\ cmdstring?
Execute the program 
.IR UnixCommand .
If the option
.I \-fake
is set: use the
.I string
to display as command. After this program has stopped the
.I cmdstring
will be evaluated if set with the option
.IR -aftercmd.
.TP
.IC pathName\  kill
Stop any running command.
.TP
.IC pathName\  runState
Returns 
.C 1
if there is a running process and
.C 0
otherwise.
.TP
.IC pathName\  clear
Delete current content of the window.
.RE
.SH OPTIONS
The
.C two_shell
command takes all options of the text(n) widget plus to following:
.RS
.TP
.CI \-prompt \ string
Set the fake
.C prompt
to
.IR string .
.TP
.CI \-destructivebs \ TCL_BOOLEAN
If set to
.CR TRUE ,
all backspaces are destructive (the default). If
.CR FALSE ,
backspace characters only move the insertion cursor
back (needed by trivial terminal emulation, e.g. for bash).
.RE
.SH VIRTUAL EVENTS
The
.C two_shell
may generate the following virtual event:
.RS
.TP
.IR <<RunningOn>>\  and\  <<RunningOff>>
Shell is currently running some program (On) or not (Off).
.RE
.SH TAGS
The
.C two_shell
uses tags to enable different formatting for commands etc.:
.RS
.TP
.C command
Command string (which may be a fake).
.TP
.C prompt
Displayed fake prompt.
.RE
.SH MARKS
Marks are used to highlight sections within the
.C two_shell
widget\'s contents:
.RS
.TP
.C command
Denotes the beginning of the current (last run) command.
.RE
.SH ELEMENTS
The
.C two_shell
is a modified (subclassed) Tk text(n) widget. The Class for
bindtags is
.IR TwoShellTerm .
.SH BUGS
There is no real terminal emulation... maybe have a closer look
at tkterm/term_expect/virterm from expect?
.SH AUTHOR
Frank J. Leitner
.br
frank@fjl.de
.SH SEE ALSO
two_text(n), expect(n).
