.TH two_splitter n panned\ widget\ geometry\ manager TWO\ library
.ds )H FJL
.ds ]W http://fjl.de/two/
.SH NAME
two_splitter \- Panned widget geometry manager
.SH SYNOPSIS
.CI package\ require\ twoSplitter \ ?1.0?
.br
.C two_splitter
.I pathName
.RI ? options ?
.SH DESCRIPTION
.C two_splitter
might be called an interactive geometry manager. Slave widgets (panes)
are arranged in rows or columns. The size of each pane can be controlled
by draging the resize handler between each pane.
.PP
The two_splitter comes in two looks: UNIX (Motif) like and windows like.
.SH COMMANDS
The
.C mdi
widget command takes the following commands (as the first argument):
.RS
.TP
.CI two_splitter \ slave\ ?slaves?\ ?options?
Add one or more
.I slave
widgets. They are always added at the end of the list of already
existing panes. Fractions are resized to make place for the new
panes.
.TP
.CI two_splitter\ forget \ slave\ ?slaves?
Remove
.I slave
widget(s) from list managed slaves. They are not destroyed, just
unmanaged. Fractions of remaining panes are resized to fill the
extra space.
.TP
.CI two_splitter\ slaves \ master
Returns a list of all slaves of the
.I master
widget. The master widget is the parent widget of all panes added
to it.
.TP
.CI two_splitter\ configure \ slave\ ?options?
Configure the look and feel of the handle between the
.I slave
widget and the next one (added just after this one).
.TP
.CI two_splitter\ cget \ slave\ option
Return configuration
.I option
of the
.I slave
widget.
.RE
.SH OPTIONS
The
.CI two_splitter
command takes the following options:
.RS
.TP
.CI \-style \ style
Set the
.I style
of the Splitter:
.C unix
for more UNIX-like or
.C windows
for a look and feel like on windows.
.TP
.CI \-orient \ orientation
Set the
.I orientation
of the splitter:
.C horizontal
or
.CR vertical .
Please note that all splitters within one frame will have the same orientation.
.TP
.CI \-dynamic \ TCL_BOOLEAN
Whether or not the panes should dynamically be resized
when dragging the splitter.
.RE
.SH ELEMENTS
Slave widgets are really managed by the
.C place
geometry manager. Only the handles for resizing the panes are new
widgets. In windows style, each handle is just a single frame
(class:
.IR TwoSplitter ).
When starting to resize, the background color is set to black.
In unix style, a handle consists of a separator frame (class:
.IR TwoSplitterSep )
and the handle itself (class:
.IR TwoSplitterHandle ).
The handles are children of the master, with the additional pathname
.C __h#
appended (the separator frame in unix style is named
.CR __h#_sep ).
.SH AUTHOR
Frank J. Leitner
.br
frank@fjl.de
.SH SEE ALSO
place(n).
