.TH two_tooltip n short\ help\ messages TWO\ library
.ds )H FJL
.ds ]W http://fjl.de/two/
.SH NAME
two_tooltip \- Short help messages (a.k.a. balloonhelp, quickhelp)
.SH SYNOPSIS
.CI package\ require\ twoTooltip \ ?1.0?
.br
.C two_tooltip
.I command
.SH DESCRIPTION
.C two_tooltip
shows little help messages if the mouse pointer rests a minimum amount
of time over a widget. A second (usually longer) help message can be used
to set the status bar. This second message sets the global variabel
.IR two_ttInfo.
.SH COMMANDS
The
.C two_tooltip
command takes the following commands (as the first argument):
.RS
.TP
.C two_tooltip\ enable
Enables tooltips. This is the default.
.TP
.C two_tooltip\ on
Same as
.CR two_tooltip\ enable .
.TP
.CR two_tooltip\ disable \ or\  off
Disables tooltips. Only affects the toplevel widgets - the global
variable
.I two_ttInfo
will still be set.
.TP
.C two_tooltip\ off
Same as
.CR two_tooltip\ disable .
.TP
.CI two_tooltip\ delay \ ?millisecs?
Query or set the delay.  The delay is in milliseconds and must
be at least 50. Returns the delay.
.TP
.CI two_tooltip\ duration \ ?millisecs?
Query or set the duration of the tooltip (how long is the tooltip
visible). The duration is in milliseconds and must be at least 50.
Returns the duration.
.TP
.CI two_tooltip\ <widget> \ ?options?
Add tooltip messages to widget.
.I options
can be
.RS
.TP
.CI \-index \ index
Used for menus: apply this tooltip
.RI ( message2 )
to the entry at position
.IR index .
.TP
.CI \-tip \ message1
Used for the tooltip message in the toplevel widgets (with some delay).
.TP
.CI -\info \ message2
Used to set the global variable
.I two_ttInfo 
(without delay). Defaults to
.IR message1.
.RE
.PP
No toplevel tooltips will be shown for menu entries (only the variable
.I two_ttInfo
will be set).
.RE
.SH GLOBAL VARIABLE
The global variable
.C two_ttInfo
contains the 
.I info
message: use it in a status bar!
.SH ELEMENTS
The toplevel tooltip widget (class:
.IR TwoToolTip ,
widget path:
.CR ._two_tooltip )
contains a label.
.SH AUTHOR
Frank J. Leitner
.br
frank@fjl.de
.SH SEE ALSO
two_toolbar(n).
